summaryrefslogtreecommitdiffstats
path: root/lumina
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2016-08-19 12:28:17 +0000
committer Eric Hameleers <alien@slackware.com>2016-08-19 12:28:17 +0000
commit5aa7d49322c9d7628f3dcce17ab6d55b0b9ef80d (patch)
tree1276e332ba4c0a39fe4b0747abbe5d0feaee1b05 /lumina
parente2ef0d8a241cf2cf75ac877692bf4209e527d34c (diff)
downloadasb-5aa7d49322c9d7628f3dcce17ab6d55b0b9ef80d.tar.gz
asb-5aa7d49322c9d7628f3dcce17ab6d55b0b9ef80d.tar.xz
Initial revision
Diffstat (limited to 'lumina')
-rwxr-xr-xlumina/build/lumina.SlackBuild218
-rw-r--r--lumina/build/lumina.xinitrc29
-rw-r--r--lumina/build/slack-desc19
-rw-r--r--lumina/build/slack-required1
4 files changed, 267 insertions, 0 deletions
diff --git a/lumina/build/lumina.SlackBuild b/lumina/build/lumina.SlackBuild
new file mode 100755
index 00000000..9d19d7fc
--- /dev/null
+++ b/lumina/build/lumina.SlackBuild
@@ -0,0 +1,218 @@
+#!/bin/sh
+# $Id$
+# Copyright 2016 Eric Hameleers <alien@slackware.com>
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: lumina
+# Descr: Desktop Environment that is fast, flexible, resource-friendly
+# URL: http://lumina-desktop.org/
+# Build needs:
+# Needs:
+# Changelog:
+# 1.0.0.p1-1: 17/Aug/2016 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh lumina.SlackBuild' to build a Slackware package.
+# The package (.t?z) and .txt file as well as build logs are created in /tmp .
+# Install the package using 'installpkg' or 'upgradepkg --install-new'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=lumina
+SRCVER=${SRCVER:-"1.0.0"}
+SRCPL=${SRCPL:-"-p1"}
+VERSION=$(echo ${SRCVER}${SRCPL} |tr '-' '.')
+I18N=${I18N:-"1.0.0"}
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:-" -j4 "}
+TAG=${TAG:-alien}
+
+DOCS="DEPENDENCIES DeveloperGuidelines.txt LICENSE README.md ROADMAP luminaKeys.txt"
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE[0]="$SRCDIR/${PRGNAM}-${VERSION}.tar.gz"
+SRCURL[0]="https://github.com/trueos/${PRGNAM}/archive/v${SRCVER}-Release${SRCPL}.tar.gz"
+
+SOURCE[1]="$SRCDIR/${PRGNAM}-i18n-${I18N}.tar.gz"
+SRCURL[1]="https://github.com/trueos/${PRGNAM}-i18n/archive/v${I18N}-Release.tar.gz"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# You can use your own private machine.conf file to overrule machine defaults:
+if [ -e $SRCDIR/machine.conf ]; then
+ . $SRCDIR/machine.conf
+elif [ -e /etc/slackbuild/machine.conf ]; then
+ . /etc/slackbuild/machine.conf
+else
+ # Automatically determine the architecture we're building on:
+ MARCH=$( uname -m )
+ if [ -z "$ARCH" ]; then
+ case "$MARCH" in
+ i?86) export ARCH=i486 ;;
+ armv7hl) export ARCH=$MARCH ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$MARCH ;;
+ esac
+ fi
+ # Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
+ case "$ARCH" in
+ i486) SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ *) SLKCFLAGS=${SLKCFLAGS:-"O2"}
+ SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+ ;;
+ esac
+fi
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
+ if ! [ -f ${SOURCE[$i]} ]; then
+ echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
+ if [ -f ${SOURCE[$i]} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL[$i]}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE[$i])"
+ wget --no-check-certificate --content-disposition -nv -T 20 -O "${SOURCE[$i]}" "${SRCURL[$i]}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
+ echo "Fail to download '$(basename ${SOURCE[$i]})'. Aborting the build."
+ mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE[$i]})' not available. Aborting the build."
+ exit 1
+ fi
+ fi
+done
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE[0]}
+cd ${PRGNAM}-${SRCVER}-Release${SRCPL}
+chown -R root:root .
+chmod -R u+w,go+r-w,a+rX-st .
+
+echo Building ...
+qmake-qt5 \
+ PREFIX=/usr \
+ LIBPREFIX=/usr/lib${LIBDIRSUFFIX} \
+ QMAKE_CFLAGS="$SLKCFLAGS" \
+ QMAKE_CXXFLAGS="$SLKCFLAGS" \
+ QT5LIBDIR=/usr/lib${LIBDIRSUFFIX}/qt5
+make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+make INSTALL_ROOT=$PKG install 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
+
+# Install localizations:
+mkdir -p $PKG/usr/share/lumina-desktop
+tar xf ${SOURCE[1]} -C $PKG/usr/share/lumina-desktop/
+mv $PKG/usr/share/lumina-desktop/{lumina-i18n-${I18N}-Release,i18n}
+
+# Install entries for xwmconfig:
+mkdir -p $PKG/etc/X11/xinit
+install -m 0755 $SRCDIR/lumina.xinitrc $PKG/etc/X11/xinit/xinitrc.lumina
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/slack-required > $PKG/install/slack-required
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
+
+# Restore the original umask:
+umask ${_UMASK_}
+
diff --git a/lumina/build/lumina.xinitrc b/lumina/build/lumina.xinitrc
new file mode 100644
index 00000000..85e88685
--- /dev/null
+++ b/lumina/build/lumina.xinitrc
@@ -0,0 +1,29 @@
+#!/bin/sh
+
+userresources=$HOME/.Xresources
+usermodmap=$HOME/.Xmodmap
+sysresources=/etc/X11/xinit/.Xresources
+sysmodmap=/etc/X11/xinit/.Xmodmap
+
+# merge in defaults and keymaps
+
+if [ -f $sysresources ]; then
+ xrdb -merge $sysresources
+fi
+if [ -f $sysmodmap ]; then
+ xmodmap $sysmodmap
+fi
+if [ -f $userresources ]; then
+ xrdb -merge $userresources
+fi
+if [ -f $usermodmap ]; then
+ xmodmap $usermodmap
+fi
+
+# Start the window manager:
+if [ -z "$DESKTOP_SESSION" -a -x /usr/bin/ck-launch-session ]; then
+ exec ck-launch-session start-lumina-desktop
+else
+ exec start-lumina-desktop
+fi
+
diff --git a/lumina/build/slack-desc b/lumina/build/slack-desc
new file mode 100644
index 00000000..8b9fc36d
--- /dev/null
+++ b/lumina/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+lumina: lumina (Desktop Environment that is fast, flexible, lean)
+lumina:
+lumina: The Lumina Desktop Environment is a system interface designed for use
+lumina: on any Unix-like operating system.
+lumina: Lumina was designed to require as few system dependencies/requirements
+lumina: as possible. This results in a very lightweight, customizable,
+lumina: and smooth desktop experience with minimal system overhead.
+lumina:
+lumina:
+lumina: lumina home: http://lumina-desktop.org/
+lumina:
diff --git a/lumina/build/slack-required b/lumina/build/slack-required
new file mode 100644
index 00000000..7d275211
--- /dev/null
+++ b/lumina/build/slack-required
@@ -0,0 +1 @@
+qt5